<?php
/***************************************************************************
 *                       Link Exchange Mod for phpBB2 ver 1.0.3
 *                            -------------------
 *                             24 September 2005
 *                            -------------------
 *   begin                : 19 June 2004
 *   copyright            : (C) 2004-2005 George Belton
 *   email                : george@georgebelton.com
 *   $Id: admin_link_exchange.php
 *
 *   Some code borrowed from admin_banner.php in the Complete Banner Hack
 *	 by Niels < ncr@db9.dk > (Niels Chr. Rd) http://mods.db9.dk
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', 1);

if( !empty($setmodules) )
{
	$file = basename(__FILE__);
	$module['General']['Link Exchange'] = "$file";
	return;
}

//
// Let's set the root dir for phpBB
//
$phpbb_root_path = "./../";
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);
include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_link_exchange.' . $phpEx);


//
// Pull all config data
//
$sql = "SELECT * FROM " . LINK_EXCHANGE_CONFIG_TABLE;
if(!$result = $db->sql_query($sql))
{
	message_die(CRITICAL_ERROR, "Could not query Link Exchange configuration information", "", __LINE__, __FILE__, $sql);
}
else
{
	while( $row = $db->sql_fetchrow($result) )
	{
		$config_name = $row['config_name'];
		$config_value = $row['config_value'];
		$default_config[$config_name] = $config_value;

		$new[$config_name] = ( isset($HTTP_POST_VARS[$config_name]) ) ? $HTTP_POST_VARS[$config_name] : $default_config[$config_name];

		if( isset($HTTP_POST_VARS['change']) )
		{
			$sql = "UPDATE " . LINK_EXCHANGE_CONFIG_TABLE . " SET
				config_value = '" . str_replace("\'", "''", $new[$config_name]) . "'
				WHERE config_name = '$config_name'";
			if( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, "Failed to update Link Exchange configuration for $config_name", "", __LINE__, __FILE__, $sql);
			}
		}
	}

	if( isset($HTTP_POST_VARS['change']) )
	{
		   $message = $lang['Link_exchange_config_updated'] . "<br /><br />" . sprintf($lang['Click_return_linkexchangeadmin'], "<a href=\"" . append_sid("admin_link_exchange.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");
		   message_die(GENERAL_MESSAGE, $message);	
	}
}	
	
if( isset($HTTP_GET_VARS['mode']) || isset($HTTP_POST_VARS['mode']) )
{
	$mode = (isset($HTTP_GET_VARS['mode'])) ? $HTTP_GET_VARS['mode'] : $HTTP_POST_VARS['mode'];
}
else 
{
	//
	// These could be entered via a form button
	//
	if( isset($HTTP_POST_VARS['add']) )
	{
		$mode = "add";
	}
	else if( isset($HTTP_POST_VARS['save']) )
	{
		$mode = "save";
	}
	else if( isset($HTTP_POST_VARS['change']) )
	{
		$mode = "change";
	}	
	else
	{
		$mode = "";
	}
}


if( $mode!= "")
{
	if( $mode == "edit" || $mode == "add" )
	{
		//
		// They want to add a new link exchange, show the form.
		//
		if( isset($HTTP_POST_VARS['id']) || isset($HTTP_GET_VARS['id']) )
		{
			$link_exchange_id = ( isset($HTTP_POST_VARS['id']) ) ? intval($HTTP_POST_VARS['id']) : intval($HTTP_GET_VARS['id']);
		}
		else
		{
			$link_exchange_id = 0;
		}
		
		$s_hidden_fields = "";
		
		if( $mode == "edit" )
		{
			if( empty($link_exchange_id) )
			{
				message_die(GENERAL_MESSAGE, $lang['Missing_link_exchange_id']);
			}

			$sql = "SELECT * FROM " . LINK_EXCHANGE_TABLE . "
				WHERE link_id = $link_exchange_id";
			if(!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, "Couldn't obtain link exchange data", "", __LINE__, __FILE__, $sql);
			}
			
			$link_info = $db->sql_fetchrow($result);
			$s_hidden_fields .= '<input type="hidden" name="id" value="' . $link_exchange_id . '" />';
		}
		else
		{
			// Default settings for new link exchanges
			$link_info['link_active'] = 1;
		}

		$s_hidden_fields .= '<input type="hidden" name="mode" value="save" />';
		$link_exchange_is_active = ( $link_info['link_active'] ) ? "checked=\"checked\"" : "";
		$link_exchange_is_not_active = ( !$link_info['link_active'] ) ? "checked=\"checked\"" : "";
		
		$template->set_filenames(array(
			'body' => 'admin/link_exchange_edit_body.tpl')
		);
		
		$link_img = $link_info['link_img'];
		if( (0 != strpos($link_img, '.swf')) || (0 != strpos($link_img, '.SWF')) )	
		{ 
		$template->assign_block_vars('switch_flash', array(
			'U_LINK_EXCHANGE_IMG' => ( ereg("http",strtolower($link_info['link_img']))) ? $link_info['link_img'] : '../'.$link_info['link_img'],		
		)); 
		}	
		else 
		{ 
		$template->assign_block_vars('switch_not_flash', array(
			'U_LINK_EXCHANGE_IMG' => ( ereg("http",strtolower($link_info['link_img']))) ? $link_info['link_img'] : '../'.$link_info['link_img'],		
		)); 
		}			

		$template->assign_vars(array(
			'L_LINK_EXCHANGE_TITLE' => $lang['Link_exchange_title'],
			'L_LINK_EXCHANGE_TEXT' => $lang['Link_exchange_add_text'],
			'L_LINK_EXCHANGE_ACTIVATE' => $lang['Link_exchange_activate'], 
			'LINK_EXCHANGE_NOT_ACTIVE' => $link_exchange_is_not_active,
			'LINK_EXCHANGE_ACTIVE' => $link_exchange_is_active,
			'L_LINK_EXCHANGE_NAME' => $lang['Link_exchange_name'],
			'LINK_EXCHANGE_NAME' => $link_info['link_name'],			
			'L_LINK_EXCHANGE_EMAIL' => $lang['Link_exchange_email'],
			'LINK_EXCHANGE_EMAIL' => $link_info['link_email'],
			'L_LINK_EXCHANGE_WEBSITE' => $lang['Link_exchange_website'],
			'LINK_EXCHANGE_WEBSITE' => $link_info['link_website'],
			'L_LINK_EXCHANGE_WEBSITE_EXPLAIN' => $lang['Link_exchange_website_explain'],		
			'L_LINK_EXCHANGE_IMAGE' => $lang['Link_exchange_image'],
			'LINK_EXCHANGE_IMG' => $link_info['link_img'],
			'L_LINK_EXCHANGE_IMAGE_EXPLAIN' =>$lang['Link_exchange_image_explain'],					
			'L_LINK_EXCHANGE_DESCRIPTION' => $lang['Link_exchange_description'],
			'LINK_EXCHANGE_DESCRIPTION' => $link_info['link_desc'],	
			'L_LINK_EXCHANGE_DESCRIPTION_EXPLAIN' => $lang['Link_exchange_description_explain'],
			'L_LINK_EXCHANGE_URL' => $lang['Link_exchange_url'],
			'LINK_EXCHANGE_URL' => $link_info['link_url'],
			'L_LINK_EXCHANGE_URL_EXPLAIN' => $lang['Link_exchange_url_explain'],
			'LINK_EXCHANGE_OUT' => $link_info['link_out'],			
			'L_LINK_EXCHANGE_OUT' => $lang['Link_exchange_out'],			
			'L_SUBMIT' => $lang['Submit'],
			'L_RESET' => $lang['Reset'],
			'L_YES' => $lang['Yes'],
			'L_NO' => $lang['No'],		
			'S_LINK_EXCHANGE_ACTION' => append_sid("admin_link_exchange.$phpEx"),
			'S_HIDDEN_FIELDS' => $s_hidden_fields)
		);
	}
	else if( $mode == "save" )
	{
		//
		// Ok, they sent us our info, let's update it.
		//
		$link_exchange_id = ( isset($HTTP_POST_VARS['id']) ) ? intval($HTTP_POST_VARS['id']) : 0;
		$link_exchange_name = ( isset($HTTP_POST_VARS['link_exchange_name']) ) ? trim($HTTP_POST_VARS['link_exchange_name']) : "";
		$link_exchange_email = ( isset($HTTP_POST_VARS['link_exchange_email']) ) ? trim($HTTP_POST_VARS['link_exchange_email']) : "";	
		$link_exchange_website = ( isset($HTTP_POST_VARS['link_exchange_website']) ) ? trim($HTTP_POST_VARS['link_exchange_website']) : "";
		$link_exchange_image = ( isset($HTTP_POST_VARS['link_exchange_image']) ) ? trim($HTTP_POST_VARS['link_exchange_image']) : "";					
		$link_exchange_description = ( isset($HTTP_POST_VARS['link_exchange_description']) ) ? trim($HTTP_POST_VARS['link_exchange_description']) : "";
		$link_exchange_url = ( isset($HTTP_POST_VARS['link_exchange_url']) ) ? trim($HTTP_POST_VARS['link_exchange_url']) : "";
		$link_exchange_active = ( $HTTP_POST_VARS['link_exchange_active'] == 1 ) ? TRUE : 0;

		// verify the inputs
		if( $link_exchange_name == "" )
		{
			message_die(GENERAL_MESSAGE, $lang['Missing_link_exchange_name']);
		}
		if( $link_exchange_id )
		{
			$sql = "UPDATE " . LINK_EXCHANGE_TABLE . " SET 	link_active = $link_exchange_active, link_name = '" . str_replace("\'", "''", $link_exchange_name) . "', link_email = '" . str_replace("\'", "''", $link_exchange_email) . "', link_website = '" . str_replace("\'", "''", $link_exchange_website) . "', link_img = '" . str_replace("\'", "''", $link_exchange_image) . "', link_desc = '" . str_replace("\'", "''", $link_exchange_description) . "', link_url = '" . str_replace("\'", "''", $link_exchange_url) . "' 
					WHERE link_id = $link_exchange_id";
					$message = $lang['Link_exchange_updated'];
		}
		else
		{
				$sql = "SELECT MAX(link_id)+1 as link_id FROM " . LINK_EXCHANGE_TABLE; 
				if(!$result = $db->sql_query($sql)) 
				{ 
				message_die(GENERAL_ERROR, "Couldn't obtain link exchange id data", "", __LINE__, __FILE__, $sql); 
				} 
				$link_exchange_nr = $db->sql_fetchrow($result); 
				$sql = "INSERT INTO " . LINK_EXCHANGE_TABLE . " (link_id, link_name, link_email, link_website, link_img, link_desc, link_url, link_active)
					VALUES (".$link_exchange_nr[link_id].", '" . str_replace("\'", "''", $link_exchange_name) . "', '" . str_replace("\'", "''", $link_exchange_email) . "', '" . str_replace("\'", "''", $link_exchange_website) . "', '" . str_replace("\'", "''", $link_exchange_image) . "', '" . str_replace("\'", "''", $link_exchange_description) . "', '" . str_replace("\'", "''", $link_exchange_url) . "', '$link_exchange_active')";
					$message = $lang['Link_exchange_added'];
		}
		if( !$result = $db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't update/insert into link exchange table", "", __LINE__, __FILE__, $sql);
		}
		$message .= "<br /><br />" . sprintf($lang['Click_return_linkexchangeadmin'], "<a href=\"" . append_sid("admin_link_exchange.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");
		message_die(GENERAL_MESSAGE, $message);
	}
	else if( $mode == "delete" )
	{
		//
		// Ok, they lets delete the selected link exchange
		//
		
		if( isset($HTTP_POST_VARS['id']) || isset($HTTP_GET_VARS['id']) )
		{
			$link_exchange_id = ( isset($HTTP_POST_VARS['id']) ) ? intval($HTTP_POST_VARS['id']) : intval($HTTP_GET_VARS['id']);
		}
		else
		{
			$link_exchange_id = '';
		}
		
		if( $link_exchange_id )
		{
			$sql = "DELETE FROM " . LINK_EXCHANGE_TABLE . "
				WHERE link_id = $link_exchange_id";
			
			if( !$result = $db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, "Couldn't delete link exchange data", "", __LINE__, __FILE__, $sql);
			}
			$message = $lang['Link_exchange_removed'] . "<br /><br />" . sprintf($lang['Click_return_linkexchangeadmin'], "<a href=\"" . append_sid("admin_link_exchange.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");
			message_die(GENERAL_MESSAGE, $message);
		}
		else
		{
			message_die(GENERAL_MESSAGE, $lang['Missing_link_exchange_id']);
		}
	}


}
else
{
//
// Show the default page
//
$template->set_filenames(array(
	"body" => "admin/link_exchange_list_body.tpl"));

	// fetch link exchange information from databas 
	$sql = "SELECT * FROM " . LINK_EXCHANGE_TABLE ." Where link_id != 0 order by link_id";
	if( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, "Couldn't obtain link exchange data", "", __LINE__, __FILE__, $sql);
	}
	$link_exchange_count = $db->sql_numrows($result);
	$link_exchange_rows = $db->sql_fetchrowset($result);
	
	$template->assign_vars(array(
		"L_LINK_EXCHANGE_TITLE" => $lang['Link_exchange_title'],
		"L_LINK_EXCHANGE_TEXT" => $lang['Link_exchange_text'],
		"L_LINK_EXCHANGE_CONFIG" => $lang['Link_exchange_config'],
		"L_LINK_EXCHANGE_LINKS_NUM" => $lang['Link_exchange_pagination'],
		"L_LINK_EXCHANGE_LINKS_NUM_EXPLAIN" => $lang['Link_exchange_pagination_explain'],
		"L_LINK_EXCHANGE_BANNER" => $lang['Link_exchange_banner'],
		"L_LINK_EXCHANGE_BANNER_EXPLAIN" => $lang['Link_exchange_banner_explain'],
		"L_LINK_EXCHANGE_URL" => $lang['Link_exchange_url'],
		"L_LINK_EXCHANGE_URL_EXPLAIN" => $lang['Link_exchange_url_explain'],				
		"L_LINK_EXCHANGE_DESC" => $lang['Link_exchange_desc'],
		"L_LINK_EXCHANGE_DESC_EXPLAIN" => $lang['Link_exchange_desc_explain'],
		"L_LINK_EXCHANGE_DESCRIPTION" => $lang['Link_exchange_description'],
		"L_LINK_EXCHANGE_ACTIVATED" => $lang['Link_exchange_activated'],
		"L_LINK_EXCHANGE_OUT" => $lang['Link_exchange_out'],		
		"L_LINK_EXCHANGE_WEBSITE" => $lang['Link_exchange_website'],
		"L_EDIT" => $lang['Edit'],
		"L_DELETE" => $lang['Delete'],
		"L_CHANGE_LINK_EXCHANGE_CONFIG" => $lang['Submit'],
		"L_ADD_LINK_EXCHANGE" => $lang['Add_new_link_exchange'],
		"L_ACTION" => $lang['Action'],		
		"S_LINK_EXCHANGE_ACTION" => append_sid("admin_link_exchange.$phpEx"),
		"CONFIG_PAGINATION" => $new['config_pagination'],
		"CONFIG_BANNER" => $new['config_banner'],
		"CONFIG_URL" => $new['config_url'],
		"CONFIG_DESC" => $new['config_desc'])
	);
	
	for($i = 0; $i < $link_exchange_count; $i++)
	{
		$link_exchange_website = $link_exchange_rows[$i]['link_website'];
		$link_exchange_id = $link_exchange_rows[$i]['link_id'];
		$row_color = ( !($i % 2) ) ? $theme['td_color1'] : $theme['td_color2'];
		$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];
		$link_exchange_is_active = ( $link_exchange_rows[$i]['link_active'] ) ? $lang['Yes'] : $lang['No'];
		$link_exchange_clicks_out = $link_exchange_rows[$i]['link_out'];

		$template->assign_block_vars("links", array(
			'ROW_COLOR' => "#" . $row_color,
			'ROW_CLASS' => $row_class,
			'LINK_EXCHANGE_DESCRIPTION' => $link_exchange_rows[$i]['link_desc'],
			'LINK_EXCHANGE_IS_ACTIVE' => $link_exchange_is_active,
			'LINK_EXCHANGE_CLICKS_OUT' => $link_exchange_clicks_out,
			'LINK_EXCHANGE_WEBSITE' => $link_exchange_website,
			'LINK_EXCHANGE_ID' => $link_exchange_id,
			'U_LINK_EXCHANGE_EDIT' => append_sid("admin_link_exchange.$phpEx?mode=edit&amp;id=$link_exchange_id"),
			'U_LINK_EXCHANGE_DELETE' => append_sid("admin_link_exchange.$phpEx?mode=delete&amp;id=$link_exchange_id"))
		);
	}
}

$template->pparse("body");
include('./page_footer_admin.'.$phpEx);
?>