<?php
/***************************************************************************
 *                       Link Exchange Mod for phpBB2 ver 1.0.3 
 *                            -------------------
 *                             24 September 2005
 *                            -------------------
 *   begin                : 19 June 2004
 *   copyright            : (C) 2004-2005 George Belton
 *   email                : george@georgebelton.com
 *   $Id: link_submission.php
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
 
define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

$start = ( isset($HTTP_GET_VARS['start']) ) ? $HTTP_GET_VARS['start'] : 0; 

// ------------------------
// START SESSION MANAGEMENT
// ------------------------
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);
// ------------------------
// END SESSION MANAGEMENT
// ------------------------

include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_link_exchange.' . $phpEx);

// ------------------------------------
// PULL OUT LINK EXCHANGE CONFIG DATA
// ------------------------------------
$sql = "SELECT * FROM " . LINK_EXCHANGE_CONFIG_TABLE;
if(!$result = $db->sql_query($sql))
{
	message_die(CRITICAL_ERROR, "Could not query Link Exchange configuration information", "", __LINE__, __FILE__, $sql);
}
else
{
	while( $row = $db->sql_fetchrow($result) )
	{
		$config_name = $row['config_name'];
		$config_value = $row['config_value'];
		$default_config[$config_name] = $config_value;

		$new[$config_name] = $default_config[$config_name];
		$config_banner = $new['config_banner'];
		$config_url = $new['config_url'];
		$config_desc = $new['config_desc'];

	}
}	

// ----------------------------------
// SET UP DEFAULT EMAIL VARIABLES
// ----------------------------------
$script_name = preg_replace('/^\/?(.*?)\/?$/', '\1', trim($board_config['script_path']));
$script_name = ( $script_name != '' ) ? $script_name . '/link_submission.'.$phpEx : 'link_submission.'.$phpEx;
$server_name = trim($board_config['server_name']);
$server_protocol = ( $board_config['cookie_secure'] ) ? 'https://' : 'http://';
$server_port = ( $board_config['server_port'] <> 80 ) ? ':' . trim($board_config['server_port']) . '/' : '/';
$server_url = $server_protocol . $server_name . $server_port . $script_name;

// ---------------------------------
// SET UP SOME ADDITIONAL VARIABLES
// ---------------------------------
$sitename = $board_config['sitename'];
$website = $server_protocol . $server_name;
$page_title = '' . $sitename . ' Link Exchange';
$l_link_exch_sub = $lang['Link_exchange_submission'];
$l_link_exch_sub = sprintf($l_link_exch_sub, $sitename);
$l_link_exch_sub_open = $lang['Link_exchange_submission_opening'];              
$l_link_exch_sub_open = sprintf($l_link_exch_sub_open, $sitename, $sitename);

		// -----------------------------------------------------------------------
		// IF MODE IS SUBMIT THEN CHECK DATA, UPDATE DATABASE, THEN SEND AN EMAIL
		// -----------------------------------------------------------------------
		if ( isset($HTTP_POST_VARS['submit']) )
		{
				// -----------------------
				// SET UP THE VARIABLES
				// -----------------------
				$name = ( isset($HTTP_POST_VARS['name']) ) ? trim($HTTP_POST_VARS['name']) : "";
				$email_from = ( isset($HTTP_POST_VARS['email']) ) ? trim($HTTP_POST_VARS['email']) : "";	
				$website = ( isset($HTTP_POST_VARS['website']) ) ? trim($HTTP_POST_VARS['website']) : "";
				$banner = ( isset($HTTP_POST_VARS['banner']) ) ? trim($HTTP_POST_VARS['banner']) : "";		
				$site_desc = ( isset($HTTP_POST_VARS['site_desc']) ) ? trim($HTTP_POST_VARS['site_desc']) : "";
				$links_url = ( isset($HTTP_POST_VARS['links_url']) ) ? trim($HTTP_POST_VARS['links_url']) : "";
				$comments = ( isset($HTTP_POST_VARS['comments']) ) ? trim($HTTP_POST_VARS['comments']) : "";
		
				$subject = 'Link exchange request from ' . $name . ' about ' . $website . '';
				$email = $board_config['board_email'];
					// ----------------------			
					// GET THE NEXT LINK ID			
					// ----------------------
					$sql = "SELECT MAX(link_id)+1 as link_id FROM " . LINK_EXCHANGE_TABLE; 
				    if(!$result = $db->sql_query($sql)) 
					{ 
					  message_die(GENERAL_ERROR, "Couldn't obtain link exchange id data", "", __LINE__, __FILE__, $sql); 
					} 
				    $link_exchange_nr = $db->sql_fetchrow($result); 
					$sql = "INSERT INTO " . LINK_EXCHANGE_TABLE . " (link_id, link_name, link_email, link_website, link_img, link_desc, link_url, link_active)
							VALUES (".$link_exchange_nr[link_id].", '" . str_replace("\'", "''", $name) . "', '" . str_replace("\'", "''", $email_from) . "', '" . str_replace("\'", "''", $website) . "', '" . str_replace("\'", "''", $banner) . "', '" . str_replace("\'", "''", $site_desc) . "', '" . str_replace("\'", "''", $links_url) . "', '0')";
					if( !$result = $db->sql_query($sql) )
					{
						message_die(GENERAL_ERROR, "Couldn't insert into link exchange table", "", __LINE__, __FILE__, $sql);
					}	
					
					// --------------------------------------------------------
					// NO ERRORS SO WE CAN NOTIFY THE ADMIN OF THE SUBMISSION
					// --------------------------------------------------------
					include($phpbb_root_path . 'includes/emailer.'.$phpEx);
					$emailer = new emailer($board_config['smtp_delivery']);
					
					$email_headers = 'Return-Path: ' . $email_from . "\nFrom: " . $email_from . "\n";
					$email_headers .= 'X-AntiAbuse: Board servername - ' . $server_name . "\n";
					$email_headers .= 'X-AntiAbuse: Name - ' . $name . "\n";
					$email_headers .= 'X-AntiAbuse: User IP - ' . decode_ip($user_ip) . "\n";
					
					$emailer->use_template('link_exchange_submission', $user_lang);
					$emailer->email_address($email);
					$emailer->set_subject($subject);
					$emailer->extra_headers($email_headers);

					$emailer->assign_vars(array(
						'NAME' => $name,	
						'EMAIL' => $email_from, 
						'WEBSITE' => $website,
						'BANNER' => $banner,
						'SITE_DESC' => $site_desc,
						'LINKS_URL' => $links_url,
						'COMMENTS' => $comments)
					);
					$emailer->send();
					$emailer->reset();

					// ---------------------------------			
					// LETS ALSO SEND A CC TO THE USER
					// ---------------------------------
					$subject = 'CC: Link exchange request from ' . $name . ' about ' . $website . '';
					$email_headers = 'Return-Path: ' . $email_from . "\nFrom: " . $email_from . "\n";
					$emailer->use_template('link_exchange_submission', $user_lang);
					$emailer->email_address($email_from);
					$emailer->set_subject($subject);
					$emailer->extra_headers($email_headers);

					$emailer->assign_vars(array(
						'NAME' => $name,	
						'EMAIL' => $email_from, 
						'WEBSITE' => $website,
						'BANNER' => $banner,
						'SITE_DESC' => $site_desc,
						'LINKS_URL' => $links_url,
						'COMMENTS' => $comments)
					);
					$emailer->send();
					$emailer->reset();
				

					$template->assign_vars(array(
						'META' => '<meta http-equiv="refresh" content="5;url=' . append_sid("index.$phpEx") . '">')
					);

					$message = $lang['Submission_sent'] . '<br /><br />' . sprintf($lang['Click_return_index'],  '<a href="' . append_sid("index.$phpEx") . '">', '</a>');

					message_die(GENERAL_MESSAGE, $message);
	  
		  }
	
		// --------------------------------------------
		// START OUTPUT OF PAGE IF MODE IS NOT SUBMIT
		// --------------------------------------------
		include($phpbb_root_path . 'includes/page_header.'.$phpEx);

		$template->set_filenames(array(
			'body' => 'link_exchange_submission.tpl')
		);

		$template->assign_vars(array(

			'S_POST_ACTION' => append_sid('link_submission.'.$phpEx), 
			'LINK_EXCHANGE_SUBMISSION' => $l_link_exch_sub,
			'LINK_EXCHANGE_SUBMISSION_OPEN' => $l_link_exch_sub_open,
			'LINK_EXCHANGE_SUBMISSION_CLOSE' => $lang['Link_exchange_submission_closing'],
			'LINK_EXCHANGE_BANNER' => $config_banner,
			'L_LINK_EXCHANGE_BANNER' => $lang['Link_exchange_banner'],			
			'LINK_EXCHANGE_URL' => $config_url,
			'L_LINK_EXCHANGE_URL' => $lang['Link_exchange_url'],			
			'LINK_EXCHANGE_DESC' => $config_desc,
			'L_LINK_EXCHANGE_DESC' => $lang['Link_exchange_desc'],						
			'L_NAME' => $lang['Link_exchange_submission_name'], 
			'L_EMAIL' => $lang['Link_exchange_submission_email'], 
			'L_WEBSITE' => $lang['Link_exchange_submission_website'],
			'L_BANNER' => $lang['Link_exchange_submission_banner'], 
			'L_BANNER_EXPLAIN' => $lang['Link_exchange_submission_banner_explain'], 			
			'L_SITE_DESC' => $lang['Link_exchange_submission_desc'], 
			'L_SITE_DESC_EXPLAIN' => $lang['Link_exchange_submission_desc_explain'], 			
			'L_LINKS_URL' => $lang['Link_exchange_submission_links_url'],
			'L_COMMENTS' => $lang['Link_exchange_submission_comments'],
			'L_SUBMIT' => $lang['Link_exchange_submission_submit'],
			'L_RESET' => $lang['Link_exchange_submission_reset'],
			'L_REQUIRED' => $lang['Link_exchange_submission_required'],
			'L_EMPTY_NAME_SUBMISSION' => $lang['Empty_name_submission'],
			'L_EMPTY_EMAIL_SUBMISSION' => $lang['Empty_email_submission'],
			'L_EMPTY_WEBSITE_SUBMISSION' => $lang['Empty_website_submission'],
			'L_EMPTY_BANNER_SUBMISSION' => $lang['Empty_banner_submission'],
			'L_EMPTY_SITE_DESC_SUBMISSION' => $lang['Empty_site_desc_submission'],
			'L_EMPTY_LINKS_URL_SUBMISSION' => $lang['Empty_links_url_submission'],
			'T_TR_COLOR2' => '#'.$theme['tr_color2'],
			'T_TR_COLOR3' => '#'.$theme['tr_color3'])
		);

		// ------------------
		// GENERATE THE PAGE
		// ------------------
		$template->pparse('body');
		include($phpbb_root_path . 'includes/page_tail.'.$phpEx);		
		?>